//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
                        
#include "Uplandemo.h"
#include "Uplanhelp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "planner"
#pragma link "Planner"
#pragma link "PlanPeriodEdit"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::unitgroupClick(TObject *Sender)
{
 switch (unitgroup->ItemIndex)
 {
 case 0: DayPlanner->Display->DisplayUnit=5;
         break;
 case 1: DayPlanner->Display->DisplayUnit=6;
         break;
 case 2: DayPlanner->Display->DisplayUnit=10;
         break;
 case 3: DayPlanner->Display->DisplayUnit=15;
         break;
 case 4: DayPlanner->Display->DisplayUnit=30;
         break;
 case 5: DayPlanner->Display->DisplayUnit=60;
         break;
 }

 CSpinEdit3->Value=DayPlanner->Display->DisplayStart;
 CSpinEdit4->Value=DayPlanner->Display->DisplayEnd;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit1Change(TObject *Sender)
{
 DayPlanner->Display->DisplayScale=CSpinEdit1->Value;        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit2Change(TObject *Sender)
{
 DayPlanner->Positions=CSpinEdit2->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::hourformatClick(TObject *Sender)
{
 if (hourformat->Checked) DayPlanner->HourType = ht12hrs; else
  DayPlanner->HourType=ht24hrs;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit3Change(TObject *Sender)
{
 DayPlanner->Display->DisplayStart=CSpinEdit3->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit4Change(TObject *Sender)
{
 DayPlanner->Display->DisplayEnd=CSpinEdit4->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit5Change(TObject *Sender)
{
 DayPlanner->Display->ActiveStart=CSpinEdit5->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit6Change(TObject *Sender)
{
 DayPlanner->Display->ActiveStart=CSpinEdit6->Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL)
  {
   ColorDialog1->Color=DayPlanner->Items->Selected->Color;

   if (ColorDialog1->Execute()) DayPlanner->Items->Selected->Color=ColorDialog1->Color;
  }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL)
  DayPlanner->Items->Selected->Alignment=taLeftJustify;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL)
  DayPlanner->Items->Selected->Alignment=taCenter;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL)
  DayPlanner->Items->Selected->Alignment=taRightJustify;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
 DayPlanner->SaveToHTML("test.htm");

 ShellExecute(Handle,"open","test.htm",NULL,NULL,SW_NORMAL);



}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton10Click(TObject *Sender)
{
 if (PrintDialog1->Execute()) DayPlanner->Print();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{
 TPlannerItem *plIt;

 plIt = DayPlanner->Items->Add();


 plIt->Visible=false;
 plIt->ItemPos=DayPlanner->SelPosition;
 plIt->ItemBegin=DayPlanner->SelItemBegin;
 plIt->ItemEnd=DayPlanner->SelItemEnd;
 plIt->Text->Add("This item is created");
 plIt->Text->Add("with the new button");

 plIt->Text->Add("at "+TimeToStr(Now()));

 if (CheckBox1->Checked) plIt->CaptionType=ctTime;
 if (CheckBox2->Checked) plIt->ImageID=0;
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(1);
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(2);

 plIt->FixedSize=CheckBox3->Checked;
 plIt->FixedPos=CheckBox7->Checked;
 plIt->ReadOnly=CheckBox5->Checked;

 plIt->Visible=TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
 TPlannerItem *plIt;

 DayPlanner->RichEdit->Text="Rich text";
 DayPlanner->RichEdit->SelStart=0;
 DayPlanner->RichEdit->SelLength=4;
 DayPlanner->RichEdit->SelAttributes->Color=clRed;
 DayPlanner->RichEdit->SelAttributes->Style << fsBold;
 DayPlanner->RichEdit->SelStart=5;
 DayPlanner->RichEdit->SelLength=4;
 DayPlanner->RichEdit->SelAttributes->Color=clBlue;
 DayPlanner->RichEdit->SelAttributes->Style << fsItalic;

 plIt = DayPlanner->Items->Add();

 plIt->Visible=false;
 plIt->ItemPos=DayPlanner->SelPosition;
 plIt->ItemBegin=DayPlanner->SelItemBegin;
 plIt->ItemEnd=DayPlanner->SelItemEnd;
 plIt->Text->Text=DayPlanner->RichToText();

 if (CheckBox1->Checked) plIt->CaptionType=ctTime;
 if (CheckBox2->Checked) plIt->ImageID=0;
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(1);
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(2);

 if (CheckBox1->Checked) plIt->CaptionType=ctTime;
 if (CheckBox2->Checked) plIt->ImageID=0;
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(1);
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(2);


 plIt->FixedSize=CheckBox3->Checked;
 plIt->FixedPos=CheckBox7->Checked;
 plIt->ReadOnly=CheckBox5->Checked;

 plIt->Visible=TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoldBtnClick(TObject *Sender)
{
 if (BoldBtn->Down)
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style << fsBold;
 else
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style >> fsBold;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ItalBtnClick(TObject *Sender)
{
 if (ItalBtn->Down)
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style << fsItalic;
 else
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style >> fsItalic;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::UnderBtnClick(TObject *Sender)
{
 if (UnderBtn->Down)
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style << fsUnderline;
 else
  DayPlanner->RichEdit->SelAttributes->Style = DayPlanner->RichEdit->SelAttributes->Style >> fsUnderline;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
 if (ColorDialog1->Execute())
   DayPlanner->RichEdit->SelAttributes->Color=ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
 if (FontDialog1->Execute())
 {
   DayPlanner->RichEdit->SelAttributes->Name=FontDialog1->Font->Name;
   DayPlanner->RichEdit->SelAttributes->Style=FontDialog1->Font->Style;
   DayPlanner->RichEdit->SelAttributes->Size=FontDialog1->Font->Size;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerHeaderClick(TObject *Sender,
      int SectionIdx)
{
 if (!CheckBox12->Checked) MessageDlg("you clicked header "+IntToStr(SectionIdx),mtInformation,TMsgDlgButtons() << mbOK,0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemAnchorClick(TObject *Sender,
      TPlannerItem *Item, AnsiString Anchor)
{
 ShowMessage("Clicked anchor in item : "+Anchor);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemAnchorEnter(TObject *Sender,
      TPlannerItem *Item, AnsiString Anchor)
{
   StatusBar1->SimpleText=Anchor;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemAnchorExit(TObject *Sender,
      TPlannerItem *Item, AnsiString Anchor)
{
   StatusBar1->SimpleText="";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemDelete(TObject *Sender,
      TPlannerItem *Item)
{
 Item->Free();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DayPlannerItemImageClick(TObject *Sender,
      TPlannerItem *Item, int ImageIdx)
{

 if (Item->ImageIndexList->Count>0)
 {
   if (ImageIdx==0)
   {
    if (Item->ImageIndexList->Items[0]==5)
     Item->ImageIndexList->Items[0]=6;
    else
     Item->ImageIndexList->Items[0]=5;
   }
 }
 else
   {
    if (Item->ImageID==5) Item->ImageID=6; else Item->ImageID=5;
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemInsert(TObject *Sender, int position,
      int fromSel, int fromSelPrecis, int toSel, int toSelPrecis)
{
 TPlannerItem *plIt;

 if (DayPlanner->Items->HasItem(fromSel,toSel,position))
  {
   ShowMessage("Cannot create item.  Selected period already contains an item without overlap !");
   return;
  }

 plIt = DayPlanner->Items->Add();

 plIt->Visible=false;
 plIt->ItemPos=DayPlanner->SelPosition;
 plIt->ItemBegin=DayPlanner->SelItemBegin;
 plIt->ItemEnd=DayPlanner->SelItemEnd;

 plIt->Text->Add("This item is created at");
 plIt->Text->Add("run-time in the planner");
 plIt->Text->Add("at "+TimeToStr(Now()));

 if (!CheckBox8->Checked) plIt->AllowOverlap=TRUE; else plIt->AllowOverlap=FALSE; 

 plIt->Name="Test";

 if (CheckBox1->Checked) plIt->CaptionType=ctTime;
 if (CheckBox2->Checked) plIt->ImageID=0;
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(0);
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(1);
 if (CheckBox4->Checked) plIt->ImageIndexList->Add(2);


 plIt->FixedSize=CheckBox3->Checked;
 plIt->FixedPos=CheckBox7->Checked;
 plIt->ReadOnly=CheckBox5->Checked;

 plIt->Background=CheckBox9->Checked;

 plIt->Visible = TRUE;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::DayPlannerItemRightClick(TObject *Sender,
      TPlannerItem *Item)
{
 if (Item!=NULL) ShowMessage(Item->Text->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::monthplannerItemDelete(TObject *Sender,
      TPlannerItem *Item)
{
 Item->Free();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::monthplannerPlannerRightClick(TObject *Sender,
      int position, int fromSel, int fromSelPrecis, int toSel,
      int toSelPrecis)
{
 TPlannerItem *plIt;

 plIt = monthplanner->Items->Add();
 plIt->Text->Add("Test");
 plIt->ItemEnd=toSel;
 plIt->ItemBegin=fromSel;
 plIt->ItemPos=position;
 plIt->CaptionType=ctTime;


}
//---------------------------------------------------------------------------
void __fastcall TForm1::ResPlannerDragDropCell(TObject *Sender,
      TObject *Source, int X, int Y)
{
 AnsiString selitem;
 TPlannerItem *plIt;
 TListBox *pLB;

 pLB = (TListBox *)Source;

 selitem = pLB->Items->Strings[pLB->ItemIndex].c_str();
 pLB->Items->Delete(pLB->ItemIndex);

 plIt = ResPlanner->Items->Add();
 plIt->ItemBegin=X;
 plIt->ItemEnd=X+3;
 plIt->ItemPos=Y;
 plIt->Text->Add(selitem);
 plIt->CaptionType = ctTime;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ResPlannerDragOverCell(TObject *Sender,
      TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
 Accept=false;

 if (Source==EventList)
  {
   if ((ResPlanner->CellToItem(X,Y)==NULL) &&
       (ResPlanner->CellToItem(X+1,Y)==NULL) &&
       (ResPlanner->CellToItem(X+2,Y)==NULL))
        Accept=true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ResPlannerItemAnchorClick(TObject *Sender,
      TPlannerItem *Item, AnsiString Anchor)
{
  ShellExecute(Handle,"open",Anchor.c_str(),NULL,NULL,SW_NORMAL);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 ResPlanner->InsertPosition(2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
 ResPlanner->DeletePosition(2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
 ResPlanner->MovePosition(5,3);        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
 TPlannerItem *plIt1;
 TPlannerItem *plIt2;


 ResPlanner->InsertPosition(ResPlanner->Positions);
 ResPlanner->InsertPosition(ResPlanner->Positions);

 ResPlanner->Header->Captions->Strings[ResPlanner->Positions-1]="New pos 1";
 ResPlanner->Header->Captions->Strings[ResPlanner->Positions]  ="New pos 2";

 plIt1 = ResPlanner->Items->Add();
 plIt2 = ResPlanner->Items->Add();

 plIt1->ItemBegin=5;
 plIt1->ItemEnd=10;
 plIt1->ItemPos=ResPlanner->Positions-2;
 plIt1->LinkedItem=plIt2;
 plIt1->LinkType=ltLinkFull;
 plIt1->Text->Add("Linked to 2");

 plIt2->ItemBegin=5;
 plIt2->ItemEnd=10;
 plIt2->ItemPos=ResPlanner->Positions-1;
 plIt2->Text->Add("Linked from 1");

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
 TPlannerItem *plIt1;
 TPlannerItem *plIt2;


 ResPlanner->InsertPosition(ResPlanner->Positions);
 ResPlanner->InsertPosition(ResPlanner->Positions);

 ResPlanner->Header->Captions->Strings[ResPlanner->Positions-1]="New pos 1";
 ResPlanner->Header->Captions->Strings[ResPlanner->Positions]  ="New pos 2";

 plIt1 = ResPlanner->Items->Add();
 plIt2 = ResPlanner->Items->Add();

 plIt1->ItemBegin=5;
 plIt1->ItemEnd=10;
 plIt1->ItemPos=ResPlanner->Positions-2;
 plIt1->LinkedItem=plIt2;
 plIt1->LinkType=ltLinkEndBegin;
 plIt1->Text->Add("Linked to 2");

 plIt2->ItemBegin=5;
 plIt2->ItemEnd=10;
 plIt2->ItemPos=ResPlanner->Positions-1;
 plIt2->Text->Add("Linked from 1");

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
 ResPlanner->Print();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
 ResPlanner->SaveToHTML("test.htm");
 ShellExecute(Handle,"open","test.htm",NULL,NULL,SW_NORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
 Form2->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton11Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL) DayPlanner->Items->CutToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton13Click(TObject *Sender)
{
 if (DayPlanner->Items->Selected!=NULL) DayPlanner->Items->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton14Click(TObject *Sender)
{
 DayPlanner->Items->PasteFromClipboardAtPos();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox11Click(TObject *Sender)
{
 DayPlanner->Display->ShowCurrent=CheckBox11->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox13Click(TObject *Sender)
{
 DayPlanner->Display->ShowCurrentItem=CheckBox13->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox12Click(TObject *Sender)
{
 DayPlanner->Header->DragDrop=CheckBox12->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Planner1ItemInsert(TObject *Sender, int position,
      int fromSel, int fromSelPrecis, int toSel, int toSelPrecis)
{
  TPlannerItem *plIt;

  plIt = Planner1->Items->Add();

  plIt->ItemBegin = fromSel;
  plIt->ItemEnd = toSel;
  plIt->ItemPos = position;
  plIt->CaptionType = ctTime;
  plIt->Edit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Planner1ItemDelete(TObject *Sender,
      TPlannerItem *Item)
{
  Item->Free();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button8Click(TObject *Sender)
{
  TPlannerItem *plIt;

  plIt = TLPlanner->Items->Add();
  plIt->ItemStartTime = EncodeDate(2002,12,14)+ EncodeTime(20,0,0,0);
  plIt->ItemEndTime = EncodeDate(2002,12,15)+ EncodeTime(14,0,0,0);
  plIt->ItemPos = 1;
  plIt->Text->Text = "Item created at runtime";

}
//---------------------------------------------------------------------------

